package com.search.supersearch.controller;

import co.elastic.clients.elasticsearch.ElasticsearchClient;
import co.elastic.clients.elasticsearch.core.SearchResponse;
import co.elastic.clients.elasticsearch.core.search.Hit;
import com.search.supersearch.common.R;
import com.search.supersearch.service.EsService;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.File;
import java.util.Map;

@RestController
@RequestMapping("/es")
@Slf4j
public class EsController {
    @Resource
    private ElasticsearchClient elasticsearchClient;
    @Resource
    private EsService esService;

    @SneakyThrows
    private void func(File file, String index) {
        File[] fs = file.listFiles();
        for (File f : fs) {
            //若是目录，则递归打印该目录下的文件
            if (f.isDirectory()) {
                func(f, index);
            }
            //若是文件，直接打印
            if (f.isFile()) {
                esService.saveFileByFile(f, f.getParentFile().getName());
//                System.out.println(f.getParentFile().getName());
            }
        }
    }

    @GetMapping("/init")
    @SneakyThrows
    public R<?> init(String path, String index) {
        File file = new File(path);
        func(file, index);
        return R.data(null);
    }

    @GetMapping("/copy")
    @SneakyThrows
    public R<?> copy(String index1, String index2, String index3) {
        SearchResponse<Map> search = elasticsearchClient.search(s -> s.index(index1).size(100),
                Map.class);

        for (Hit<Map> hit : search.hits().hits()) {
            log.info("== hit: {}", hit.source());
            elasticsearchClient.index(i -> i.index(index2).document(hit.source()));
            elasticsearchClient.index(i -> i.index(index3).document(hit.source()));
//            System.out.println("== hit: hit.source()" );
        }
        return R.data("jieshu");
    }
}
