package com.search.supersearch.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;

import java.io.Serializable;

/**
 * @author 喜欢番茄火锅
 * @date 2023/9/13 15:15
 */
@NoArgsConstructor
@Data
@AllArgsConstructor
@ToString
public class DocsIndex implements Serializable {
    @ApiModelProperty(value = "文件索引字段")
    private String fileIndex;
    @ApiModelProperty(value = "系统")
    private String system;
    @ApiModelProperty(value = "组织编码")
    private String tissueCoding;
    @ApiModelProperty(value = "业务数据主键")
    private String businessDataPrimaryKey;
    @ApiModelProperty(value = "分类编码")
    private String type;
    @ApiModelProperty(value = "业务实体名称")
    private String businessName;
    //    ==============//    ==============//    ==============//    ==============
    @ApiModelProperty(value = "文件内容")
    private String content;
    //    ==============//    ==============//    ==============//    ==============
    @ApiModelProperty("author")
    private String metaAuthor;
    @ApiModelProperty("date")
    private String metaDate;
    @ApiModelProperty("modifier")
    private String metaModifier;
    @ApiModelProperty("created")
    private String metaCreated;
    //    ==============//    ==============//    ==============//    ==============
    @ApiModelProperty("root")
    private String pathRoot;
    @ApiModelProperty("virtual")
    private String pathVirtual;
    @ApiModelProperty("real")
    private String pathReal;
    //    ==============//    ==============//    ==============//    ==============
    @ApiModelProperty("extension")
    private String fileExtension;
    @ApiModelProperty("content_type")
    private String fileContentType;
    @ApiModelProperty("created")
    private String fileCreated;
    @ApiModelProperty("last_modified")
    private String fileLastModified;
    @ApiModelProperty("last_accessed")
    private String fileLastAccessed;
    @ApiModelProperty("indexing_date")
    private String fileIndexingDate;
    @ApiModelProperty("filesize")
    private Integer filesize;
    @ApiModelProperty("filename")
    private String filename;
    @ApiModelProperty("url")
    private String fileUrl;

    private static final long serialVersionUID = 1L;
}
